#include <winsock.h>
#include <stdio.h>

//
// main() function of console telnet application
//
int main()
{
 int retv=0;
 WSADATA wdata;

 WSAStartup(MAKEWORD(1, 1),&wdata);

 SOCKET s=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
 if (s==INVALID_SOCKET) printf("socket()\n");

 char compname[MAX_COMPUTERNAME_LENGTH+1];
 gethostname(compname,MAX_COMPUTERNAME_LENGTH);
 hostent *hp=gethostbyname(compname);
 hp->h_addr[3]=255;

 printf("compname='%s'\n",compname);

 sockaddr_in sin;
 sin.sin_family=AF_INET;
 sin.sin_port=htons(4444);
 memcpy(&(sin.sin_addr.S_un.S_addr),hp->h_addr,hp->h_length);

 int ttl=7;	// Arbitrary TTL value.
 setsockopt(s,IPPROTO_IP,IP_MULTICAST_TTL,(char *)&ttl,sizeof(ttl));
 setsockopt(s,IPPROTO_IP,IP_MULTICAST_IF,(char *)&(sin.sin_addr.S_un.S_addr),4);

 int suc=sendto(s,compname,MAX_COMPUTERNAME_LENGTH,0,(sockaddr *)&sin,sizeof(sin));
 if (suc==SOCKET_ERROR) printf("sendto()\n");

 WSACleanup();

 return retv;
}